---
title: 'ARIA: row role'
slug: Web/Accessibility/ARIA/Roles/Row_Role
tags:
  - ARIA
  - ARIA Role
  - ARIA Row
  - ARIA Row Role
  - Accessibility
  - Reference
  - Row Role
---
<div>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</div>

<p>An element with <code>role="row"</code> is a row of cells within a tabular structure. A row contains one or more cells,  grid cells or column headers, and possibly a row header, within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a></code>, <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role">treegrid</a></code>, and optionally within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></code>.</p>

<pre class="brush: html">&lt;div role="table" aria-label="Populations" aria-describedby="country_population_desc"&gt;
   &lt;div id="country_population_desc"&gt;World Populations by Country&lt;/div&gt;
   &lt;div role="rowgroup"&gt;
      &lt;div role="row"&gt;
         &lt;span role="columnheader" aria-sort="descending"&gt;Country&lt;/span&gt;
         &lt;span role="columnheader"aria-sort="none"&gt;Population&lt;/span&gt;
      &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
        &lt;span role="cell"&gt;Finland&lt;/span&gt;
        &lt;span role="cell"&gt;5.5 million&lt;/span&gt;
     &lt;/div&gt;
     &lt;div role="row"&gt;
        &lt;span role="cell"&gt;France&lt;/span&gt;
        &lt;span role="cell"&gt;67 million&lt;/span&gt;
     &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<h2 id="Description">Description</h2>

<p>The element <code>role="row"</code> is a row within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a></code>, <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">table</a></code> or <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Treegrid_Role">treegrid</a></code>, and optionally within a <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></code>, that is a container for one or more <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Cell_Role">cells</a></code>, <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role"><code>gridcells</code></a>, <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role"><code>columnheaders</code></a>, or <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowheader_Role"><code>rowheaders</code></a> within a static tabular structure. Using native <a href="/en-US/docs/Web/HTML/Element/tr">HTML <code>&lt;tr&gt;</code></a> elements, whenever possible, is strongly encouraged.</p>

<p>To create an ARIA row, add <code>role="row"</code> to the container element. That row should be nested within a grid, table or treegrid. A group of rows can be nested within a grid, table or treegrid directly, or within a rowgroup in one of those containers. Each row contains child cells. These cells can be of different types, depending on whether they are column or row headers, or grid or regular cells.</p>

<p>A row can contain a number of attributes clarifying the row's role, including <code>aria-colindex</code>, <code>aria-level</code>, <code>aria-rowindex</code>, and <code>aria-selected</code>.</p>

<p>If the row is within a treegrid, rows can include the <code>aria-expanded</code> attribute, using the attribute to indicate the present status. This is not the case for an ordinary table or grid, in which the aria-expanded attribute is not present.</p>

<p>To create an interactive widget that has a tabular structure, use the grid pattern instead. If the interaction provides for the selection state of individual cells, if left to right and top to botton navigation is provided, or if the user interface allows the rearranging of cell order or otherwise changing individual cell order such as through drag and drop, use <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">grid</a> or <a href="/en-US/docs/">treegrid</a> instead.</p>

<div class="note">
<p>Note: Using the native HTML table element (&lt;table&gt;) along with the table row element (&lt;tr&gt;) whenever possible is strongly encouraged.</p>
</div>

<h3 id="Associated_WAI-ARIA_roles_states_and_properties">Associated WAI-ARIA roles, states, and properties</h3>

<h4 id="Context_roles">Context roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">role="rowgroup"</a></dt>
 <dd>An optional contextual row parent, it establishes a relationship between descendant rows. It is a structural equivalent to the thead, tfoot, and tbody elements in an HTML table element.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Table_Role">role="table"</a></dt>
 <dd>One of the three possible contexts (along with grid and treegrid) in which you'll find a row, it identifies the row as being part of a non-interactive table structure containing data arranged in rows and columns, similar to the native &lt;table&gt; HTML element. </dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Grid_Role">role="grid"</a></dt>
 <dd>One of the three possible contexts (along with table and treegrid) in which you'll find a row, it identifies the row as being part of a non-interactive table structure containing data arranged in rows and columns, similar to the native &lt;table&gt; HTML element.</dd>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Gridtree_Role">role="treegrid"</a></dt>
 <dd>Similar to a grid, but with rows that can be expanded and collapsed in the same manner as for a tree.</dd>
</dl>

<h4 id="Descendant_roles">Descendant roles</h4>

<dl>
 <dt><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Cell_Role">role="cell"</a></dt>
 <dd>A cell in a row within a tabular container.</dd>
 <dt><a href="/en-US/docs/en-US/docs/Web/Accessibility/ARIA/Roles/Gridcell_Role">role="gridcell"</a></dt>
 <dd>A cell in a row within a grid or treegrid.</dd>
 <dt>role="columnheader"</dt>
 <dd>A header cell that is the structural equivalent of the HTML &lt;th&gt; element with a column scope. Unlike a plain cell, the columnheader role establishes a relationship between it and all cells in the corresponding column. </dd>
 <dt>role="rowheader"</dt>
 <dd>A header cell that is the structural equivalent of the HTML &lt;th&gt; element with a row scope. Unlike a plain cell, the rowheader role establishes a relationship between it and all cells in the corresponding row. </dd>
</dl>

<h4 id="States_and_properties">States and properties</h4>

<dl>
 <dt>aria-expanded state</dt>
 <dd>
 <p>The <code>aria-expanded</code> attribute, which defines the state of the row, can take one of three values, or be omitted:</p>

 <ul>
  <li><code>aria-expanded="true</code>: Row is currently expanded.</li>
  <li><code>aria-expanded="false"</code>: Row is currently collapsed.</li>
  <li><code>aria-expended="undefined"</code> or the attribute is missing: The row is neither expandable nor collapsible.</li>
 </ul>

 <p>If the element with the aria-expanded attribute controls the expansion of another grouping container that is not 'owned by' the element, the author <strong>should </strong>reference the container by using the aria-controls attribute.</p>
 </dd>
 <dt>aria-selected state</dt>
 <dd>Only relevant if the row is in an interactive container, such as a grid or treegrid, but not relevant if the row is in a table. The <code>aria-selected</code> attribute can take one of three values, or be omitted:
 <ul>
  <li><code>aria-selected="true</code>: Row is currently selected</li>
  <li><code>aria-selected="false"</code>: Row is not currently selected.</li>
  <li><code>aria-selected="undefined"</code> or the attribute is missing: The row is not selectable. </li>
 </ul>
 </dd>
 <dt>aria-colindex attribute</dt>
 <dd>
 <p>The <code>aria-colindex</code> attribute is only needed if columns are hidden from the DOM. It is generally placed on row children, rather than on the row itself. If the columns displayed are contiguous, then it can be placed on the row.<br>
  <br>
  The attribute takes as its value an integer between 1 and the total number of columns within the table, grid or treegrid. When placed on the row, the <code>aria-colindex</code> defines an element's column index or position with respect to the total number of columns within a row. For example, in a table with 15 columns, and columns 4, 5, and 6 are in the DOM, aria-colindex="4" could be set on every row.<br>
  <br>
  If the set of columns which is present in the DOM is <strong>not </strong>contiguous, or if there are cells spanning more than one row or column, put the <code>aria-colindex</code> on all of the children of each row instead of on the row itself.</p>

 <p>If all the columns are in the DOM, this attribute is not necessary.</p>
 </dd>
 <dt>aria-rowindex attribute</dt>
 <dd>
 <p>The <code>aria-rowindex</code> attribute is only needed if rows are hidden from the DOM, to indicate which row, in the list of total rows, is being read. The attribute, placed with a unique value on each row, takes as its value an integer between 1 and the total number of rows within the table, grid or treegrid, indicating the position, or index, of each row. For example, if a table has 1,500 rows, but only the header and rows 47 and 52 are in the DOM, <code>aria-rowindex="1"</code> would be set on the header row, and <code>aria-rowindex="47"</code> and <code>aria-rowindex="52"</code> would be set on the 47th and 52nd row, respectively.</p>

 <p>If all the rows are present in the DOM, this attribute is not necessary.</p>
 </dd>
</dl>

<h3 id="Keyboard_Interactions">Keyboard Interactions</h3>

<p>None</p>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>None. For sortable columns, see the <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Columnheader_Role">columnheader</a> aria role.</p>

<div class="note">
<p><span class="ILfuVd yZ8quc">The first rule of ARIA use is you can use a native feature with the semantics and behavior you require already built in, instead of re-purposing an element and <strong>adding</strong> an ARIA role, state or property to make it accessible, then do so. Employ the HTML &lt;table&gt; element instead of the ARIA role of table whenever possible.</span></p>
</div>

<h2 id="Examples">Examples</h2>

<pre class="brush: html">&lt;div role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;div id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/div&gt;
  &lt;div role="rowgroup"&gt;
     &lt;div role="row"&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/span&gt;
       &lt;span role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/span&gt;
     &lt;/div&gt;
   &lt;/div&gt;
   &lt;div role="rowgroup"&gt;
    &lt;div role="row" aria-rowindex="11"&gt;
       &lt;span role="cell"&gt;header&lt;/span&gt;
       &lt;span role="cell"&gt;h1&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="16"&gt;
      &lt;span role="cell"&gt;header&lt;/span&gt;
      &lt;span role="cell"&gt;h6&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="18"&gt;
      &lt;span role="cell"&gt;rowgroup&lt;/span&gt;
      &lt;span role="cell"&gt;thead&lt;/span&gt;
    &lt;/div&gt;
    &lt;div role="row"  aria-rowindex="24"&gt;
      &lt;span role="cell"&gt;term&lt;/span&gt;
      &lt;span role="cell"&gt;dt&lt;/span&gt;
    &lt;/div&gt;
  &lt;/div&gt;
&lt;/div&gt;
</pre>

<p>The above is a non-semantic ARIA table with five of 81 rows present in the DOM: One within a table header and four rows within the table body. The header row, alone in a header rowgroup, has two column headers. The columns are sortable, but not currently sorted, as indicated by the aria-sort property. The table body is in a separate rowgroup, with four rows currently in the DOM. Because not all the rows are in the DOM, we've included the <code>aria-rowindex</code> property on every row.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Only use table, tbody, thead, tr, th, td, etc., for data table structure. You can add these ARIA roles to ensure accessibility should the native semantics of the table be removed, such as with CSS. A relevant use case for the ARIA table role is when the native semantics of a table are overridden by CSS's display property, such as by display: grid. In this case, you can use the ARIA table roles to add the semantics back in.</p>

<pre class="brush: html">&lt;table role="table" aria-label="Semantic Elements" aria-describedby="semantic_elements_table_desc" aria-rowcount="81"&gt;
  &lt;caption id="semantic_elements_table_desc"&gt;Semantic Elements to use instead of ARIA's roles&lt;/caption&gt;
  &lt;thead role="rowgroup"&gt;
     &lt;tr role="row"&gt;
       &lt;th role="columnheader" aria-sort="none"&gt;ARIA Role&lt;/th&gt;
       &lt;th role="columnheader" aria-sort="none"&gt;Semantic Element&lt;/th&gt;
     &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody role="rowgroup"&gt;
     &lt;tr role="row" aria-rowindex="11"&gt;
       &lt;td role="cell"&gt;header&lt;/td&gt;
       &lt;td role="cell"&gt;h1&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row" aria-rowindex="16"&gt;
       &lt;td role="cell"&gt;header&lt;/td&gt;
       &lt;td role="cell"&gt;h6&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row" aria-rowindex="18"&gt;
       &lt;td role="cell"&gt;rowgroup&lt;/td&gt;
       &lt;td role="cell"&gt;thead&lt;/td&gt;
     &lt;/tr&gt;
     &lt;tr role="row" aria-rowindex="24"&gt;
       &lt;td role="cell"&gt;term&lt;/td&gt;
       &lt;td role="cell"&gt;dt&lt;/td&gt;
     &lt;/tr&gt;
   &lt;/tbody&gt;
 &lt;/table&gt;</pre>

<p>Above is the semantic way of writing a table. The ARIA roles are only necessary if the native semantics of the table, and therefore the table rows, are obliterated, such as via setting the <a href="/en-US/docs/Web/CSS/display#Accessibility_concerns">display property to flex or grid</a>.</p>

<h3 id="Added_benefits">Added benefits</h3>

<p>none</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#row","ARIA row role")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
  <tr>
   <td>{{SpecName("ARIA Authoring Practices","#row","ARIA row role")}}</td>
   <td>{{Spec2('ARIA Authoring Practices')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/tr">HTML table row</a></li>
</ul>
